3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
35 # The function takes at most 2 arguments. The first argument is the
36 # URL that navigates to the submodule origin repo. When relative, this URL
37 # is relative to the superproject origin URL repo. The second up_path
38 # argument, if specified, is the relative path that navigates
39 # from the submodule working tree to the superproject working tree.
41 # The output of the function is the origin URL of the submodule.
43 # The output will either be an absolute URL or filesystem path (if the
44 # superproject origin URL is an absolute URL or filesystem path,
45 # respectively) or a relative file system path (if the superproject
46 # origin URL is a relative file system path).
48 # When the output is a relative file system path, the path is either
49 # relative to the submodule working tree, if up_path is specified, or to
50 # the superproject working tree otherwise.
51 resolve_relative_url ()
53 remote=$(get_default_remote)
54 remoteurl=$(git config "remote.$remote.url") ||
55 remoteurl=$(pwd) # the repository is its own authoritative upstream
57 remoteurl=${remoteurl%/}
70 remoteurl="./$remoteurl"
81 remoteurl="${remoteurl%/*}"
84 remoteurl="${remoteurl%:*}"
88 if test -z "$is_relative" || test "." = "$remoteurl"
90 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
104 remoteurl="$remoteurl$sep${url%/}"
105 echo "${is_relative:+${up_path}}${remoteurl#./}"
109 # Get submodule info for registered submodules
110 # $@ = path to limit submodule list
115 git ls-files --error-unmatch --stage -- "$@" ||
116 echo "unmatched pathspec exists"
120 my ($null_sha1) = ("0" x 40);
124 if (/^unmatched pathspec/) {
129 my ($mode, $sha1, $stage, $path) =
130 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
131 next unless $mode eq "160000";
133 if (!$unmerged{$path}++) {
134 push @out, "$mode $null_sha1 U\t$path\n";
141 print "#unmatched\n";
150 if test "$1" = "#unmatched"
157 # Print a submodule configuration setting
159 # $1 = submodule name
163 # Checks in the usual git-config places first (for overrides),
164 # otherwise it falls back on .gitmodules. This allows you to
165 # distribute project-wide defaults in .gitmodules, while still
166 # customizing individual repositories if necessary. If the option is
167 # not in .gitmodules either, print a default value.
169 get_submodule_config () {
173 value=$(git config submodule."$name"."$option")
176 value=$(git config -f .gitmodules submodule."$name"."$option")
178 printf '%s' "${value:-$default}"
183 # Map submodule path to submodule name
189 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
191 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
192 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
193 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
195 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
202 # Prior to calling, cmd_update checks that a possibly existing
203 # path is not a git repository.
204 # Likewise, cmd_add checks that path does not exist at all,
205 # since it is the location of a new submodule.
214 if test -n "$GIT_QUIET"
221 base_name=$(dirname "$name")
223 gitdir=$(git rev-parse --git-dir)
224 gitdir_base="$gitdir/modules/$base_name"
225 gitdir="$gitdir/modules/$name"
230 rm -f "$gitdir/index"
232 mkdir -p "$gitdir_base"
235 git clone $quiet -n ${reference:+"$reference"} \
236 --separate-git-dir "$gitdir" "$url" "$sm_path"
238 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
241 # We already are at the root of the work tree but cd_to_toplevel will
242 # resolve any symlinks that might be present in $PWD
243 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
244 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
245 # normalize Windows-style absolute paths to POSIX-style absolute paths
246 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
247 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
248 # Remove all common leading directories after a sanity check
249 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
250 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
252 while test "${a%%/*}" = "${b%%/*}"
257 # Now chop off the trailing '/'s that were added in the beginning
261 # Turn each leading "*/" component into "../"
262 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
263 echo "gitdir: $rel/$a" >"$sm_path/.git"
265 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
266 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
271 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
275 # Add a new submodule to the working tree, .gitmodules and the index
279 # optional branch is stored in global branch variable
283 # parse $args after "submodule ... add".
288 case "$2" in '') usage ;; esac
299 case "$2" in '') usage ;; esac
300 reference="--reference=$2"
307 case "$2" in '') usage ;; esac
328 if test -z "$sm_path"; then
329 sm_path=$(echo "$repo" |
330 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
333 if test -z "$repo" -o -z "$sm_path"; then
337 # assure repo is absolute or relative to parent
340 # dereference source url relative to parent's url
341 realrepo=$(resolve_relative_url "$repo") || exit
348 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
353 # multiple //; leading ./; /./; /../; trailing /
354 sm_path=$(printf '%s/\n' "$sm_path" |
364 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
365 die "$(eval_gettext "'\$sm_path' already exists in the index")"
367 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
369 eval_gettextln "The following path is ignored by one of your .gitignore files:
371 Use -f if you really want to add it." >&2
375 if test -n "$custom_name"
377 sm_name="$custom_name"
382 # perhaps the path exists and is already a git repo, else clone it
383 if test -e "$sm_path"
385 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
387 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
389 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
393 if test -d ".git/modules/$sm_name"
397 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
398 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
399 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
400 echo >&2 " $realrepo"
401 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
402 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
404 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
407 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" || exit
411 # ash fails to wordsplit ${branch:+-b "$branch"...}
413 '') git checkout -f -q ;;
414 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
416 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
418 git config submodule."$sm_name".url "$realrepo"
420 git add $force "$sm_path" ||
421 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
423 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
424 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
427 git config -f .gitmodules submodule."$sm_name".branch "$branch"
429 git add --force .gitmodules ||
430 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
434 # Execute an arbitrary command sequence in each checked out
437 # $@ = command to execute
441 # parse $args after "submodule ... foreach".
463 # dup stdin so that it can be restored when running the external
464 # command in the subshell (and a recursive call to this function)
468 while read mode sha1 stage sm_path
470 die_if_unmatched "$mode"
471 if test -e "$sm_path"/.git
473 say "$(eval_gettext "Entering '\$prefix\$sm_path'")"
474 name=$(module_name "$sm_path")
476 prefix="$prefix$sm_path/"
478 # we make $path available to scripts ...
482 if test -n "$recursive"
484 cmd_foreach "--recursive" "$@"
487 die "$(eval_gettext "Stopping at '\$sm_path'; script returned non-zero status.")"
493 # Register submodules in .git/config
495 # $@ = requested paths (default to all)
499 # parse $args after "submodule ... init".
521 while read mode sha1 stage sm_path
523 die_if_unmatched "$mode"
524 name=$(module_name "$sm_path") || exit
526 # Copy url setting when it is not set yet
527 if test -z "$(git config "submodule.$name.url")"
529 url=$(git config -f .gitmodules submodule."$name".url)
531 die "$(eval_gettext "No url found for submodule path '\$sm_path' in .gitmodules")"
533 # Possibly a url relative to parent
536 url=$(resolve_relative_url "$url") || exit
539 git config submodule."$name".url "$url" ||
540 die "$(eval_gettext "Failed to register url for submodule path '\$sm_path'")"
542 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$sm_path'")"
545 # Copy "update" setting when it is not set yet
546 upd="$(git config -f .gitmodules submodule."$name".update)"
548 test -n "$(git config submodule."$name".update)" ||
549 git config submodule."$name".update "$upd" ||
550 die "$(eval_gettext "Failed to register update mode for submodule path '\$sm_path'")"
555 # Update each submodule path to correct revision, using clone and checkout as needed
557 # $@ = requested paths (default to all)
561 # parse $args after "submodule ... update".
585 case "$2" in '') usage ;; esac
586 reference="--reference=$2"
587 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
613 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
619 cmd_init "--" "$@" || return
625 while read mode sha1 stage sm_path
627 die_if_unmatched "$mode"
630 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
633 name=$(module_name "$sm_path") || exit
634 url=$(git config submodule."$name".url)
635 branch=$(get_submodule_config "$name" branch master)
636 if ! test -z "$update"
638 update_module=$update
640 update_module=$(git config submodule."$name".update)
643 if test "$update_module" = "none"
645 echo "Skipping submodule '$prefix$sm_path'"
651 # Only mention uninitialized submodules when its
652 # path have been specified
654 say "$(eval_gettext "Submodule path '\$prefix\$sm_path' not initialized
655 Maybe you want to use 'update --init'?")"
659 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
661 module_clone "$sm_path" "$name" "$url" "$reference" || exit
662 cloned_modules="$cloned_modules;$name"
665 subsha1=$(clear_local_git_env; cd "$sm_path" &&
666 git rev-parse --verify HEAD) ||
667 die "$(eval_gettext "Unable to find current revision in submodule path '\$prefix\$sm_path'")"
672 if test -z "$nofetch"
674 # Fetch remote before determining tracking $sha1
675 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
676 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
678 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
679 sha1=$(clear_local_git_env; cd "$sm_path" &&
680 git rev-parse --verify "${remote_name}/${branch}") ||
681 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
684 if test "$subsha1" != "$sha1" -o -n "$force"
687 # If we don't already have a -f flag and the submodule has never been checked out
688 if test -z "$subsha1" -a -z "$force"
693 if test -z "$nofetch"
695 # Run fetch only if $sha1 isn't present or it
696 # is not reachable from a ref.
697 (clear_local_git_env; cd "$sm_path" &&
698 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
699 test -z "$rev") || git-fetch)) ||
700 die "$(eval_gettext "Unable to fetch in submodule path '\$prefix\$sm_path'")"
703 # Is this something we just cloned?
704 case ";$cloned_modules;" in
706 # then there is no local change to integrate
711 case "$update_module" in
714 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$prefix\$sm_path'")"
715 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': rebased into '\$sha1'")"
716 must_die_on_failure=yes
720 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$prefix\$sm_path'")"
721 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': merged in '\$sha1'")"
722 must_die_on_failure=yes
725 command="git checkout $subforce -q"
726 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$prefix\$sm_path'")"
727 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': checked out '\$sha1'")"
731 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
734 elif test -n "$must_die_on_failure"
736 die_with_status 2 "$die_msg"
738 err="${err};$die_msg"
743 if test -n "$recursive"
746 prefix="$prefix$sm_path/"
749 eval cmd_update "$orig_flags"
754 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$prefix\$sm_path'")"
757 err="${err};$die_msg"
760 die_with_status $res "$die_msg"
787 git describe "$2" 2>/dev/null ||
788 git describe --tags "$2" 2>/dev/null ||
789 git describe --contains "$2" 2>/dev/null ||
790 git describe --all --always "$2"
793 test -z "$revname" || revname=" ($revname)"
796 # Show commit summary for submodules in index or working tree
798 # If '--cached' is given, show summary between index and given commit,
799 # or between working tree and given commit
801 # $@ = [commit (default 'HEAD'),] requested paths (default all)
808 # parse $args after "submodule ... summary".
823 isnumber "$summary_limit" || usage
827 summary_limit="${1#--summary-limit=}"
828 isnumber "$summary_limit" || usage
844 test $summary_limit = 0 && return
846 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
850 elif test -z "$1" -o "$1" = "HEAD"
852 # before the first commit: compare with an empty tree
853 head=$(git hash-object -w -t tree --stdin </dev/null)
854 test -z "$1" || shift
862 die "$(gettext "The --cached option cannot be used with the --files option")"
868 # Get modified modules cared by user
869 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
870 sane_egrep '^:([0-7]* )?160000' |
871 while read mod_src mod_dst sha1_src sha1_dst status name
873 # Always show modules deleted or type-changed (blob<->module)
874 test $status = D -o $status = T && echo "$name" && continue
875 # Also show added or modified modules which are checked out
876 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
881 test -z "$modules" && return
883 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
884 sane_egrep '^:([0-7]* )?160000' |
886 while read mod_src mod_dst sha1_src sha1_dst status name
888 if test -z "$cached" &&
889 test $sha1_dst = 0000000000000000000000000000000000000000
893 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
895 100644 | 100755 | 120000)
896 sha1_dst=$(git hash-object $name)
902 eval_gettextln "unexpected mode \$mod_dst" >&2
909 test $mod_src = 160000 &&
910 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
913 test $mod_dst = 160000 &&
914 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
918 case "$missing_src,$missing_dst" in
920 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
923 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
926 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
931 if test $mod_src = 160000 -a $mod_dst = 160000
933 range="$sha1_src...$sha1_dst"
934 elif test $mod_src = 160000
940 GIT_DIR="$name/.git" \
941 git rev-list --first-parent $range -- | wc -l
943 total_commits=" ($(($total_commits + 0)))"
947 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
948 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
951 blob="$(gettext "blob")"
952 submodule="$(gettext "submodule")"
953 if test $mod_dst = 160000
955 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
957 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
960 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
964 # Don't give error msg for modification whose dst is not submodule
965 # i.e. deleted or changed to blob
966 test $mod_dst = 160000 && echo "$errmsg"
968 if test $mod_src = 160000 -a $mod_dst = 160000
971 test $summary_limit -gt 0 && limit="-$summary_limit"
972 GIT_DIR="$name/.git" \
973 git log $limit --pretty='format: %m %s' \
974 --first-parent $sha1_src...$sha1_dst
975 elif test $mod_dst = 160000
977 GIT_DIR="$name/.git" \
978 git log --pretty='format: > %s' -1 $sha1_dst
980 GIT_DIR="$name/.git" \
981 git log --pretty='format: < %s' -1 $sha1_src
987 if test -n "$for_status"; then
988 if [ -n "$files" ]; then
989 gettextln "Submodules changed but not updated:" | git stripspace -c
991 gettextln "Submodule changes to be committed:" | git stripspace -c
993 printf "\n" | git stripspace -c
1000 # List all submodules, prefixed with:
1001 # - submodule not initialized
1002 # + different revision checked out
1004 # If --cached was specified the revision in the index will be printed
1005 # instead of the currently checked out revision.
1007 # $@ = requested paths (default to all)
1011 # parse $args after "submodule ... status".
1039 while read mode sha1 stage sm_path
1041 die_if_unmatched "$mode"
1042 name=$(module_name "$sm_path") || exit
1043 url=$(git config submodule."$name".url)
1044 displaypath="$prefix$sm_path"
1045 if test "$stage" = U
1047 say "U$sha1 $displaypath"
1050 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
1052 say "-$sha1 $displaypath"
1055 set_name_rev "$sm_path" "$sha1"
1056 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1058 say " $sha1 $displaypath$revname"
1060 if test -z "$cached"
1062 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1063 set_name_rev "$sm_path" "$sha1"
1065 say "+$sha1 $displaypath$revname"
1068 if test -n "$recursive"
1071 prefix="$displaypath/"
1076 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1081 # Sync remote urls for submodules
1082 # This makes the value for remote.$remote.url match the value
1083 # specified in .gitmodules.
1112 while read mode sha1 stage sm_path
1114 die_if_unmatched "$mode"
1115 name=$(module_name "$sm_path")
1116 url=$(git config -f .gitmodules --get submodule."$name".url)
1118 # Possibly a url relative to parent
1121 # rewrite foo/bar as ../.. to find path from
1122 # submodule work tree to superproject work tree
1123 up_path="$(echo "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1124 # guarantee a trailing /
1125 up_path=${up_path%/}/ &&
1126 # path from submodule work tree to submodule origin repo
1127 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1128 # path from superproject work tree to submodule origin repo
1129 super_config_url=$(resolve_relative_url "$url") || exit
1132 sub_origin_url="$url"
1133 super_config_url="$url"
1137 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1139 say "$(eval_gettext "Synchronizing submodule url for '\$prefix\$sm_path'")"
1140 git config submodule."$name".url "$super_config_url"
1142 if test -e "$sm_path"/.git
1147 remote=$(get_default_remote)
1148 git config remote."$remote".url "$sub_origin_url"
1150 if test -n "$recursive"
1152 prefix="$prefix$sm_path/"
1161 # This loop parses the command line arguments to find the
1162 # subcommand name to dispatch. Parsing of the subcommand specific
1163 # options are primarily done by the subcommand implementations.
1164 # Subcommand specific options such as --branch and --cached are
1165 # parsed here as well, for backward compatibility.
1167 while test $# != 0 && test -z "$command"
1170 add | foreach | init | update | status | summary | sync)
1200 # No command word defaults to "status"
1201 if test -z "$command"
1211 # "-b branch" is accepted only by "add"
1212 if test -n "$branch" && test "$command" != add
1217 # "--cached" is accepted only by "status" and "summary"
1218 if test -n "$cached" && test "$command" != status -a "$command" != summary